--define locals
local Events = {
	["UPDATE_BATTLEFIELD_STATUS"] = 1,--battleground and arena
	["LFG_PROPOSAL_SHOW"] = 1,--lfg tool
	["BATTLEFIELD_MGR_ENTRY_INVITE"] = 1,--wintergrasp, tol barad, etc.
	["PARTY_INVITE_REQUEST"] = 1,--party invite
	["DUEL_REQUESTED"] = 1,--duel invite
	["READY_CHECK"] = 1,--ready check requested
	["CONFIRM_SUMMON"]= 1,--player is summoned
	["PET_BATTLE_QUEUE_PROPOSE_MATCH"] = 1,--pet battle invite
}

local TimerFrame = CreateFrame("Frame")

local function Unmute(Soundtime)
	local LastUpdate = 0

	local AllSound_Old = GetCVar("Sound_EnableAllSound")
	local SFXSound_Old = GetCVar("Sound_EnableSFX")
		
	--unmute if sound is off
	if (AllSound_Old == "0") then
		SetCVar("Sound_EnableAllSound",1)
	end
	if (SFXSound_Old == "0") then
		SetCVar("Sound_EnableSFX",1)
	end
	
	--play "new" sound when sound was off
	if (SFXSound_Old == "0") or (AllSound_Old == "0") then
		PlaySoundFile("Sound\\Interface\\iPlayerInviteA.ogg","SFX")
		TimerFrame:SetScript("OnUpdate", function(self, elapsed)
			LastUpdate = LastUpdate + elapsed
			if LastUpdate > Soundtime then
				--remute sound
				if (AllSound_Old == "0") then
					SetCVar("Sound_EnableAllSound",0)
				end
				if (SFXSound_Old == "0") then
					SetCVar("Sound_EnableSFX",0)
				end
				TimerFrame:SetScript("OnUpdate",nil)
			end
		end)
	end
end

local WasNotConfirm = {}
for i = 1, GetMaxBattlefieldID() do
	WasNotConfirm[i] = true
end

local EventFrame = CreateFrame("Frame")
for i in pairs(Events) do
	EventFrame:RegisterEvent(i)
end

EventFrame:SetScript("OnEvent",function(self,event,...)
	if event == "UPDATE_BATTLEFIELD_STATUS" then
		for i = 1, GetMaxBattlefieldID() do
			local status, mapName, instanceID, lowestlevel, highestlevel, teamSize, registeredMatch = GetBattlefieldStatus(i)
			if status == "confirm" then
				if WasNotConfirm[i] then
					WasNotConfirm[i] = false
					Unmute(2)
				end
			else
				WasNotConfirm[i] = true
			end
		end
	else
		Unmute(2)
	end
end)